RaamatukoguAPP11/RaamatukoguAPP11/Controllers/RaamatsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using RaamatukoguAPP11;
using System.IO;
using Newtonsoft.Json;



namespace RaamatukoguAPP11.Controllers
{

    public class RaamatsController : Controller
    {
        private RaamatukoguEntities db = new RaamatukoguEntities();
        [Authorize]
        public ActionResult RaamatuPilt(int? id)
        {
            if (id == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            Raamat r = db.Raamat.Find(id.Value);
            if (r == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            if (r.Pilt?.Length == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            var pilt = r.Pilt.ToArray();
            return File(pilt, "image/jpg");
        }

        //public string Raamat(int? id)//See oli see API teema vist
        //{
        //    if (id == null) return null;
        //    Raamat r = db.Raamat.Find(id.Value);
        //    if (r == null) return null;
        //    string s = JsonConvert.SerializeObject(new { r.Kood, r.Isbn, r.Tiitel, r.Autor, r.Aasta, r.Kategooria.Kategooria1 });
        //    return s;
        //}

        // GET: Raamats
        //public ActionResult Index()
        //{
        //    return View(db.Raamat.ToList().Skip(1).OrderBy(x=>x.Tiitel));//Skipib nullraamatu ja paneb tähestiku järjekorda
        //}
        [Authorize]
        public ActionResult Index(string searching)
        {
            Kasutaja k = Kasutaja.ByEmail(User.Identity.Name);
            if (k == null) return RedirectToAction("Index", "Home");
            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Admin"))
            {
                return View(db.Raamat.Where(x => (x.Tiitel.Contains(searching)
            || x.Autor.Contains(searching)
            || x.Kategooria.Kategooria1.Contains(searching))
            || searching == null).ToList().SkipWhile(y => y.Kood == 0).OrderBy(y => y.Tiitel));
            }
            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Moderaator"))
            {
                return View(db.Raamat.Where(x => (x.Tiitel.Contains(searching)
                || x.Autor.Contains(searching)
                || x.Kategooria.Kategooria1.Contains(searching))
                || searching == null).ToList().SkipWhile(y => y.Kood == 0).OrderBy(y => y.Tiitel));
            }
            else
                return RedirectToAction("Index", "Home");

        }
        [Authorize]
        // GET: Raamats/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Raamat raamat = db.Raamat.Find(id);
            if (raamat == null)
            {
                return HttpNotFound();
            }
            Kasutaja k = Kasutaja.ByEmail(User.Identity.Name);
            if (k == null) return RedirectToAction("Index", "Home");
            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Admin"))
            {
                return View(raamat);
            }
            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Moderaator"))
            {
                return View(raamat);
            }

            else
                return RedirectToAction("Index", "Home");

        }

        // GET: Raamats/Create
        [Authorize]
        public ActionResult Create(string ISBN)
        {
            Kasutaja k = Kasutaja.ByEmail(User.Identity.Name);
            if (k == null) return RedirectToAction("Index", "Home");
            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Admin"))
            {
                Raamat raamat = new Raamat();
                if (ISBN != null)
                {
                    raamat.Isbn = ISBN;

                }

                ViewBag.KategooriaKood = new SelectList(db.Kategooria.OrderBy(x => x.Kategooria1), "Kood", "Kategooria1");

                return View("Create", raamat);
            }

            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Moderaator"))
            {
                Raamat raamat = new Raamat();
                if (ISBN != null)
                {
                    raamat.Isbn = ISBN;

                }

                ViewBag.KategooriaKood = new SelectList(db.Kategooria.OrderBy(x => x.Kategooria1), "Kood", "Kategooria1");

                return View("Create", raamat);
            }

            else
                return RedirectToAction("Index", "Home");

        }
        [Authorize]
        public ActionResult GenereeriIsbn()
        {

            Random random = new Random();
            string r = "";
                       
            for (int i = 1; i < 13; i++)
            {
                r += random.Next(0, 9).ToString();
            }
          
            return Create("x"+r);

        }
        [Authorize]

        // POST: Raamats/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "Kood,Isbn,Tiitel,Autor,Aasta,Pilt,KategooriaKood")] Raamat raamat, HttpPostedFileBase file)
        {
            Kasutaja k = Kasutaja.ByEmail(User.Identity.Name);
            if (k == null) return RedirectToAction("Index", "Home");
            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Admin"))
            {
                if (ModelState.IsValid)
                {

                    if (file != null && file.ContentLength > 0)
                    {
                        using (BinaryReader br = new BinaryReader(file.InputStream))
                        {
                            byte[] buff = br.ReadBytes(file.ContentLength);
                            raamat.Pilt = buff;
                        }
                    }
                    db.Raamat.Add(raamat);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
                ViewBag.KategooriaKood = new SelectList(db.Kategooria.OrderBy(x => x.Kategooria1), "Kood", "Kategooria1", raamat.KategooriaKood);
                return View(raamat);
            }
            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Moderaator"))
            {
                if (ModelState.IsValid)
                {

                    if (file != null && file.ContentLength > 0)
                    {
                        using (BinaryReader br = new BinaryReader(file.InputStream))
                        {
                            byte[] buff = br.ReadBytes(file.ContentLength);
                            raamat.Pilt = buff;
                        }
                    }
                    db.Raamat.Add(raamat);
                    db.SaveChanges();
                    return RedirectToAction("Index");
                }
                ViewBag.KategooriaKood = new SelectList(db.Kategooria.OrderBy(x => x.Kategooria1), "Kood", "Kategooria1", raamat.KategooriaKood);
                return View(raamat);
            }
            else
                return RedirectToAction("Index", "Home");

        }

        [Authorize]
        // GET: Raamats/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Raamat raamat = db.Raamat.Find(id);
            if (raamat == null)
            {
                return HttpNotFound();
            }
            Kasutaja k = Kasutaja.ByEmail(User.Identity.Name);
            if (k == null) return RedirectToAction("Index", "Home");
            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Admin"))
            {
                ViewBag.KategooriaKood = new SelectList(db.Kategooria.OrderBy(x => x.Kategooria1), "Kood", "Kategooria1", raamat.KategooriaKood);
                return View(raamat);
            }
            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Moderaator"))
            {
                ViewBag.KategooriaKood = new SelectList(db.Kategooria.OrderBy(x => x.Kategooria1), "Kood", "Kategooria1", raamat.KategooriaKood);
                return View(raamat);
            }
            else
                return RedirectToAction("Index", "Home");


        }
        [Authorize]
        // POST: Raamats/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "Kood,Isbn,Tiitel,Autor,Aasta,Pilt,KategooriaKood")] Raamat raamat, HttpPostedFileBase file)
        {
            Kasutaja k = Kasutaja.ByEmail(User.Identity.Name);
            if (k == null) return RedirectToAction("Index", "Home");
            if (k.KasutajaInRoll.Select(x => x.Roll.Nimetus).Contains("Admin"))
            {
                if (ModelState.IsValid)
                {
                    db.Entry(raamat).State = EntityState.Modified;
                    db.Entry(raamat).Property(x => x.Pilt).IsModified = false;
                    if (file != null && file.ContentLength > 0)
                    {
                        using (BinaryReader br = new BinaryReader(file.InputStream))
                        {
                            byte[] buff = br.ReadBytes(file.ContentLength);
                            raamat.Pilt = buff;
                        }
                    }

                    db.SaveChanges();
                    return RedirectToAction("Index");

RaamatukoguAPP11/RaamatukoguAPP11/Views/Raamats/Create.cshtml
@model RaamatukoguAPP11.Raamat

@{
    ViewBag.Title = "Uus";
}

<h2>Sisesta andmebaasi uus raamat</h2>


@using (Html.BeginForm("Create", "Raamats", FormMethod.Post, new { enctype = "multipart/form-data" })) // parameetreid on vaja juhul kui create nupp ei lähe create actionresulti. Anname jõuliselt ette.
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <h4>Raamat</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.Isbn, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Isbn, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ActionLink("Kliki siin, kui raamatul ei ole ISBN koodi", "GenereeriIsbn")
                @Html.ValidationMessageFor(model => model.Isbn, "", new { @class = "text-danger" })
            </div>
        </div>
        
        <div class="form-group">
            @Html.LabelFor(model => model.Tiitel, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Tiitel, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Tiitel, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Autor, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Autor, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Autor, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Aasta, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Aasta, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Aasta, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Pilt, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <img src='@Url.Action("RaamatuPilt", "Raamats", new { id = Model.Kood } )' height="10" />
            </div>
            <div class="col-md-10">
                @*<label for="file">Vaheta pilt:</label>*@
                <input type="file" name="file" id="file" class="btn btn-default" />
            </div>
        </div>

        <div class="form-group">
            @Html.Label("Kategooria", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("KategooriaKood", null, htmlAttributes: new { @class = "form-control" })
                @Html.ValidationMessageFor(model => model.KategooriaKood, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Sisesta" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Raamatute nimekiri", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

RaamatukoguAPP11/RaamatukoguAPP11/Views/Raamats/Delete.cshtml
@model RaamatukoguAPP11.Raamat

@{
    ViewBag.Title = "Kustuta";
}

<h2>Kustuta raamat</h2>

<h3>Kas soovid raamatu andmebaasist kustutada?</h3>
<div>
    <h4>Raamat</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Isbn)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Isbn)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Tiitel)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Tiitel)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Autor)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Autor)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Aasta)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Aasta)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Pilt)
        </dt>

        <dd>
            @*@Html.DisplayFor(model => model.Pilt)*@
            <img src='@Url.Action( "RaamatuPilt", "Raamats", new { id = Model.Kood } )' height="300" />
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Kustuta" class="btn btn-default" /> |
            @Html.ActionLink("Raamatute nimekiri", "Index")
        </div>
    }
</div>

RaamatukoguAPP11/RaamatukoguAPP11/Views/Raamats/Details.cshtml
@model RaamatukoguAPP11.Raamat

@{
    ViewBag.Title = "VaataRaamat";
}

<h2>Raamatu andmed</h2>

<div>
    <h4>Raamat</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Isbn)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Isbn)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Tiitel)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Tiitel)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Autor)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Autor)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Aasta)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Aasta)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.Pilt)
        </dt>

        <dd>
            @*@Html.DisplayFor(model => model.Pilt)*@
            <img src='@Url.Action( "RaamatuPilt", "Raamats", new { id = Model.Kood } )' height="300" />
        </dd>

        <dt>
            Kategooria
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Kategooria.Kategooria1)
        </dd>

    </dl>
</div>
<p>
    @Html.ActionLink("Muuda", "Edit", new { id = Model.Kood }) |
    @Html.ActionLink("Raamatute nimekiri", "Index")
</p>

RaamatukoguAPP11/RaamatukoguAPP11/Views/Raamats/Edit.cshtml
@model RaamatukoguAPP11.Raamat

@{
    ViewBag.Title = "MuudaRaamat";
}

<h2>Muuda raamatu andmeid andmebaasis</h2>


@using (Html.BeginForm("Edit", "Raamats", FormMethod.Post, new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>Raamat</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.Kood)

        <div class="form-group">
            @Html.LabelFor(model => model.Isbn, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Isbn, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Isbn, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Tiitel, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Tiitel, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Tiitel, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Autor, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Autor, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Autor, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Aasta, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Aasta, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Aasta, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Pilt, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                <img src='@Url.Action("RaamatuPilt", "Raamats", new { id = Model.Kood } )' height="300" />
            </div>
            <div class="col-md-10">
                @*<label for="file">Vaheta pilt:</label>*@
                <input type="file" name="file" id="file" class="btn btn-default" />
            </div>
        </div>
        
        <div class="form-group">
            @Html.Label("Kategooria", htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.DropDownList("KategooriaKood", null, htmlAttributes: new { @class = "form-control" } )
                @Html.ValidationMessageFor(model => model.KategooriaKood, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Muuda" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Raamatute nimekiri", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

RaamatukoguAPP11/RaamatukoguAPP11/Views/Raamats/Index.cshtml
@model IEnumerable<RaamatukoguAPP11.Raamat>

@{
    ViewBag.Title = "Raamatud";
}

<h2>Kõikide andmebaasis olevate raamatute nimekiri</h2>

<p>
    @Html.ActionLink("Lisa uus raamat", "Create")
</p>

@using (Html.BeginForm("Index", "Raamats", FormMethod.Get))
{
    <p>
        Otsi raamatut selle tiitli, autori või kategooria järgi: @Html.TextBox("searching")
        <input type="submit" value="Otsi" />
    </p>
}
<table class="table">
    <tr>
        <th>
            @Html.DisplayNameFor(model => model.Isbn)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Tiitel)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Autor)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Aasta)
        </th>
        <th>
            @Html.DisplayNameFor(model => model.Pilt)
        </th>
        <th>
            Kategooria
        </th>
        <th></th>
    </tr>

@foreach (var item in Model) {
    <tr>
        <td>
            @Html.DisplayFor(modelItem => item.Isbn)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Tiitel)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Autor)
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Aasta)
        </td>
        <td>
            @*@Html.DisplayFor(modelItem => item.Pilt)*@
            <img src='@Url.Action( "RaamatuPilt", "Raamats", new { id = item.Kood } )' height="100" />
        </td>
        <td>
            @Html.DisplayFor(modelItem => item.Kategooria.Kategooria1)
        </td>
        <td>
            @Html.ActionLink("Muuda", "Edit", new { id = item.Kood })<br />
            @Html.ActionLink("Vaata", "Details", new { id = item.Kood })<br />
            @Html.ActionLink("Kustuta", "Delete", new { id = item.Kood })
        </td>
    </tr>
}

</table>